# Installation
> `npm install --save @types/circular-dependency-plugin`

# Summary
This package contains type definitions for circular-dependency-plugin (https://github.com/aackerman/circular-dependency-plugin).

# Details
Files were exported from https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/circular-dependency-plugin.
## [index.d.ts](https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/circular-dependency-plugin/index.d.ts)
````ts
// Type definitions for circular-dependency-plugin 5.0
// Project: https://github.com/aackerman/circular-dependency-plugin
// Definitions by: Olegs Jeremejevs <https://github.com/jeremejevs>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// TypeScript Version: 3.7

import { Plugin, Module, compilation } from 'webpack';

export = CircularDependencyPlugin;

/**
 * Detect modules with circular dependencies when bundling with webpack.
 */
declare class CircularDependencyPlugin extends Plugin {
  constructor(options?: CircularDependencyPlugin.Options);
  // Not exposing `isCyclic` because it isn't meant to be public, I believe
}

declare namespace CircularDependencyPlugin {
  interface Options {
    /**
     * @default false
     */
    allowAsyncCycles?: boolean | undefined;
    /**
     * @default process.cwd()
     */
    cwd?: string | undefined;
    /**
     * @default /$^/
     */
    exclude?: RegExp | undefined;
    /**
     * @default /.*\/
     */
    include?: RegExp | undefined;
    /**
     * @default false
     */
    failOnError?: boolean | undefined;
    /**
     * @default false
     */
    onDetected?: false | ((x: {
      module: Module;
      paths: string[];
      compilation: compilation.Compilation;
    }) => void) | undefined;
    onEnd?: ((x: { compilation: compilation.Compilation }) => void) | undefined;
    onStart?: ((x: { compilation: compilation.Compilation }) => void) | undefined;
  }
}

````

### Additional Details
 * Last updated: Tue, 06 Jul 2021 18:05:52 GMT
 * Dependencies: [@types/webpack](https://npmjs.com/package/@types/webpack)
 * Global values: none

# Credits
These definitions were written by [Olegs Jeremejevs](https://github.com/jeremejevs).
